## buildbot 2.10.1

=== Makefile ===
# developer utilities
DOCKERBUILD := docker build --build-arg http_proxy=$$http_proxy --build-arg https_proxy=$$https_proxy
ROOT_DIR := $(shell dirname $(realpath $(firstword $(MAKEFILE_LIST))))

.PHONY: docs pylint flake8 virtualenv


VENV_NAME := .venv$(VENV_PY_VERSION)
PIP ?= $(ROOT_DIR)/$(VENV_NAME)/bin/pip
PYTHON ?= $(ROOT_DIR)/$(VENV_NAME)/bin/python
VENV_PY_VERSION ?= python3

WWW_PKGS := www/base www/console_view www/grid_view www/waterfall_view www/wsgi_dashboards www/badges
WWW_EX_PKGS := www/nestedexample www/codeparameter
WWW_DEP_PKGS := www/guanlecoja-ui www/data_module
ALL_PKGS := master worker pkg $(WWW_PKGS)

WWW_PKGS_FOR_UNIT_TESTS := $(filter-out www/badges, $(WWW_DEP_PKGS) $(WWW_PKGS))

ALL_PKGS_TARGETS := $(addsuffix _pkg,$(ALL_PKGS))
.PHONY: $(ALL_PKGS_TARGETS)

# build rst documentation
docs:
	$(MAKE) -C master/docs dev
	@echo "You can now open master/docs/_build/html/index.html"

docs-towncrier:
	if command -v towncrier >/dev/null 2>&1 ;\
	then \
	towncrier --draft | grep  'No significant changes.' || yes n | towncrier ;\
	fi

docs-spelling:
	$(MAKE) -C master/docs SPHINXOPTS=-W spelling

docs-linkcheck:
	$(MAKE) -C master/docs SPHINXOPTS=-q linkcheck

docs-release: docs-towncrier
	$(MAKE) -C master/docs

docs-release-spelling: docs-towncrier
	$(MAKE) -C master/docs SPHINXOPTS=-W spelling

# pylint the whole sourcecode (validate.sh will do that as well, but only process the modified files)
pylint:
	$(MAKE) -C master pylint; master_res=$$?; \
	$(MAKE) -C worker pylint; worker_res=$$?; \
	if [ $$master_res != 0 ] || [ $$worker_res != 0 ]; then exit 1; fi

# flake8 the whole sourcecode (validate.sh will do that as well, but only process the modified files)
flake8:
	$(MAKE) -C master flake8
	$(MAKE) -C worker flake8
	flake8 --config=common/flake8rc www/*/buildbot_*/
	flake8 --config=common/flake8rc www/*/setup.py
	flake8 --config=common/flake8rc common/*.py

frontend_deps: $(VENV_NAME)
	$(PIP) install -e pkg
	$(PIP) install mock wheel buildbot
	cd www/build_common; yarn install --pure-lockfile
	for i in $(WWW_DEP_PKGS); \
		do (cd $$i; yarn install --pure-lockfile; yarn run build); done

frontend_tests: frontend_deps
	for i in $(WWW_PKGS); \
		do (cd $$i; yarn install --pure-lockfile); done
	for i in $(WWW_PKGS_FOR_UNIT_TESTS); \
		do (cd $$i; yarn run build-dev || exit 1; yarn run test || exit 1) || exit 1; done

frontend_tests_headless: frontend_deps
	for i in $(WWW_PKGS); \
		do (cd $$i; yarn install --pure-lockfile); done
	for i in $(WWW_PKGS_FOR_UNIT_TESTS); \
		do (cd $$i; yarn run build-dev || exit 1; yarn run test --browsers BBChromeHeadless || exit 1) || exit 1; done

# rebuild front-end from source
frontend: frontend_deps
	for i in pkg $(WWW_PKGS); do $(PIP) install -e $$i || exit 1; done

# build frontend wheels for installation elsewhere
frontend_wheels: frontend_deps
	for i in pkg $(WWW_PKGS); \
		do (cd $$i; $(PYTHON) setup.py bdist_wheel || exit 1) || exit 1; done

# do installation tests. Test front-end can build and install for all install methods
frontend_install_tests: frontend_deps
	trial pkg/test_buildbot_pkg.py

# upgrade FE dependencies
frontend_yarn_upgrade:
	for i in $(WWW_PKGS) $(WWW_EX_PKGS) $(WWW_DEP_PKGS); \
		do (cd $$i; echo $$i; rm -rf yarn.lock; yarn install || echo $$i failed); done

# install git hooks for validating patches at commit time
hooks:
	cp common/hooks/* `git rev-parse --git-dir`/hooks
rmpyc:
	find master worker \( -name '*.pyc' -o -name '*.pyo' \) -exec rm -v {} \;

isort:
	isort -rc worker master
	git diff --name-only --stat "HEAD" | grep '.py$$' | xargs autopep8 -i
	git add -u


docker: docker-buildbot-worker docker-buildbot-master
	echo done
docker-buildbot-worker:
	$(DOCKERBUILD) -t buildbot/buildbot-worker:master worker
docker-buildbot-master:
	$(DOCKERBUILD) -t buildbot/buildbot-master:master master

$(VENV_NAME):
	virtualenv -p $(VENV_PY_VERSION) $(VENV_NAME)
	$(PIP) install -U pip setuptools

# helper for virtualenv creation
virtualenv: $(VENV_NAME)   # usage: make virtualenv VENV_PY_VERSION=python3.4
	$(PIP) install -e pkg \
		-e 'master[tls,test,docs]' \
		-e 'worker[test]' \
		buildbot_www packaging towncrier
	@echo now you can type following command  to activate your virtualenv
	@echo . $(VENV_NAME)/bin/activate

TRIALOPTS?=buildbot

.PHONY: trial
trial: virtualenv
	. $(VENV_NAME)/bin/activate && trial $(TRIALOPTS)

release_notes: $(VENV_NAME)
	test ! -z "$(VERSION)"  #  usage: make release_notes VERSION=0.9.2
	yes | towncrier --version $(VERSION) --date `date -u  +%F`
	git commit -m "Release notes for $(VERSION)"

$(ALL_PKGS_TARGETS): cleanup_for_tarballs frontend_deps
	. $(VENV_NAME)/bin/activate && ./common/maketarball.sh $(patsubst %_pkg,%,$@)

cleanup_for_tarballs:
	find master pkg worker www -name VERSION -exec rm {} \;
	rm -rf dist
	mkdir dist
.PHONY: cleanup_for_tarballs
tarballs: $(ALL_PKGS_TARGETS)
.PHONY: tarballs

# helper for release creation
release: virtualenv
	test ! -z "$(VERSION)"  #  usage: make release VERSION=0.9.2
	test -d "../bbdocs/.git"  #  make release should be done with bbdocs populated at the same level as buildbot dir
	GPG_TTY=`tty` git tag -a -sf v$(VERSION) -m "TAG $(VERSION)"
	git push buildbot "v$(VERSION)"  # tarballs are made by circleci.yml, and create a github release
	export VERSION=$(VERSION) ; . .venv/bin/activate && make docs-release
	rm -rf ../bbdocs/docs/$(VERSION)  # in case of re-run
	cp -r master/docs/_build/html ../bbdocs/docs/$(VERSION)
	cd ../bbdocs && git pull
	. .venv/bin/activate && cd ../bbdocs && make && git add . && git commit -m $(VERSION) && git push
	@echo When tarballs have been generated by circleci:
	@echo make finishrelease

finishrelease:
	rm -rf dist
	python3 ./common/download_release.py
	rm -rf ./dist/v*
	twine upload --sign dist/*

pyinstaller: virtualenv
	$(PIP) install pyinstaller
	$(VENV_NAME)/bin/pyinstaller -F pyinstaller/buildbot-worker.spec

=== worker/Makefile ===
# developer utilities
pylint:
	pylint -j4 --rcfile=../common/pylintrc --disable=super-with-arguments,raise-missing-from buildbot_worker setup.py

flake8:
	flake8 --config=../common/flake8rc buildbot_worker setup.py

=== master/docs/manual/_images/Makefile ===

SOURCES = overview_src.svg changes_src.svg workers_src.svg master_src.svg
SVGS = $(patsubst %_src.svg,%.svg,$(SOURCES))
PNGS = $(patsubst %_src.svg,%.png,$(SOURCES))

.PHONY: images-svg images-png images-eps
all: $(SVGS) $(PNGS) $(EPSS)
images-svg: $(SVGS)
images-png: $(PNGS)

# Source SVG files contains text labels in "Noto Sans" font which may not be
# installed on end user machine. Render these text labels into paths.
# "Noto Sans" font can be downloaded from Google Fonts collection.
%.svg: %_src.svg
	cp $< _tmp.svg
	# Render text as path.
	inkscape _tmp.svg --verb EditSelectAll --verb=ObjectToPath --verb FileSave --verb FileQuit
	# Cleanup SVG to reduce its size.
	scour --enable-comment-stripping --remove-metadata -i _tmp.svg -o $@
	rm -f _tmp.svg
%.png: %.svg
	inkscape -b white --export-png $@ $<
	mogrify -trim +repage $@
clean:
	rm -f $(PNGS) $(SVGS)

=== debian/changelog ===
buildbot (2.10.1-1) unstable; urgency=medium

  * New upstream version 2.10.1

 -- Robin Jarry <robin@jarry.cc>  Mon, 01 Feb 2021 23:19:47 +0100

buildbot (2.10.0-1) unstable; urgency=medium

  * New upstream version 2.10.0
  * Bump Standards-Version to 4.5.1

 -- Robin Jarry <robin@jarry.cc>  Tue, 05 Jan 2021 10:08:12 +0100

buildbot (2.8.4-2) unstable; urgency=medium

  * d/patches: fix tests with python 3.9 (Closes: #975808)

 -- Robin Jarry <robin@jarry.cc>  Thu, 26 Nov 2020 11:19:44 +0100

buildbot (2.8.4-1) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/control: Update Maintainer field with new Debian Python Team
    contact address.
  * d/control: Update Vcs-* fields with new Debian Python Team Salsa
    layout.

  [ Robin Jarry ]
  * New upstream version 2.8.4

 -- Robin Jarry <robin@jarry.cc>  Fri, 23 Oct 2020 18:00:41 +0200

=== debian/control ===
Source: buildbot
Section: devel
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Robin Jarry <robin@jarry.cc>
Standards-Version: 4.5.1
Build-Depends:
 debhelper-compat (= 13),
 dh-python (>= 3.20180313~),
 bash-completion,
 po-debconf,
 git,
 python3 (>= 3.5),
 python3-setuptools (>= 8.0),
 python3-autobahn (>= 0.16.0),
 python3-dateutil (>= 1.5),
 python3-future,
 python3-idna,
 python3-jinja2 (>= 2.1),
 python3-jwt,
 python3-migrate (>= 0.9),
 python3-openssl,
 python3-parameterized,
 python3-pkg-resources (>= 8.0),
 python3-service-identity,
 python3-sqlalchemy (>= 1.2.0),
 python3-twisted (>= 17.9.0),
 python3-txaio (>= 2.2.2),
 python3-zope.interface (>= 4.1.1),
 python3-mock,
 python3-treq,
 python3-yaml,
 python3-sphinx,
 python3-sphinx-rtd-theme,
 python3-docutils,
 sphinx-doc,
 sphinx-common,
 scdoc,
Homepage: https://buildbot.net
Vcs-Git: https://salsa.debian.org/python-team/packages/buildbot.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/buildbot
Rules-Requires-Root: no

Package: buildbot
Architecture: all
Depends:
 ${misc:Depends},
 ${python3:Depends},
 python3-autobahn (>= 0.16.0),
 python3-dateutil (>= 1.5),
 python3-idna,
 python3-jinja2 (>= 2.1),
 python3-jwt,
 python3-migrate (>= 0.9),
 python3-openssl,
 python3-pkg-resources (>= 8.0),
 python3-service-identity,
 python3-sqlalchemy (>= 1.2.0),
 python3-twisted (>= 17.9.0),
 python3-txaio (>= 2.2.2),
 python3-zope.interface (>= 4.1.1),
 passwd,
 lsb-base,
Breaks:
 python3-buildbot (<< 1.7.0),
Replaces:
 python3-buildbot (<< 1.7.0),
Recommends:
 buildbot-worker,
 bash-completion,
Suggests:
 buildbot-doc,
 python3-lz4,
 python3-psycopg2 | python3-mysqldb,
Description: System to automate the compile/test cycle (server)
 The BuildBot is a system to automate the compile/test cycle required
 by most software projects to validate code changes. By automatically
 rebuilding and testing the tree each time something has changed,
 build problems are pinpointed quickly, before other developers are
 inconvenienced by the failure. The guilty developer can be identified
 and harassed without human intervention.
 .
 By running the builds on a variety of platforms, developers who do
 not have the facilities to test their changes everywhere before
 checkin will at least know shortly afterwards whether they have
 broken the build or not. Warning counts, lint checks, image size,
 compile time, and other build parameters can be tracked over time,
 are more visible, and are therefore easier to improve.
 .
 This package contains the master server.

Package: buildbot-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Breaks:
 buildbot (<< 1.0),
 python3-buildbot-doc (<< 1.7.0),
Replaces:
 buildbot (<< 1.0),
 python3-buildbot-doc (<< 1.7.0),
Description: System to automate the compile/test cycle (documentation)
 The BuildBot is a system to automate the compile/test cycle required
 by most software projects to validate code changes. By automatically
 rebuilding and testing the tree each time something has changed,
 build problems are pinpointed quickly, before other developers are
 inconvenienced by the failure. The guilty developer can be identified
 and harassed without human intervention.
 .
 By running the builds on a variety of platforms, developers who do
 not have the facilities to test their changes everywhere before
 checkin will at least know shortly afterwards whether they have
 broken the build or not. Warning counts, lint checks, image size,
 compile time, and other build parameters can be tracked over time,
 are more visible, and are therefore easier to improve.
 .
 This package contains the HTML documentation for both the master
 and worker.

Package: buildbot-worker
Architecture: all
Depends:
 ${misc:Depends},
 ${python3:Depends},
 python3-future,
 python3-twisted (>= 17.9.0),
 passwd,
 lsb-base,
Breaks:
 buildbot-slave (<< 1.0),
 python3-buildbot-worker (<< 1.7.0),
Replaces:
 buildbot-slave (<< 1.0),
 python3-buildbot-worker (<< 1.7.0),
Recommends:
 bzr | subversion | cvs | mercurial | darcs | git,
Description: System to automate the compile/test cycle (worker agent)
 The BuildBot is a system to automate the compile/test cycle required
 by most software projects to validate code changes. By automatically
 rebuilding and testing the tree each time something has changed,
 build problems are pinpointed quickly, before other developers are
 inconvenienced by the failure. The guilty developer can be identified
 and harassed without human intervention.
 .
 By running the builds on a variety of platforms, developers who do
 not have the facilities to test their changes everywhere before
 checkin will at least know shortly afterwards whether they have
 broken the build or not. Warning counts, lint checks, image size,
 compile time, and other build parameters can be tracked over time,
 are more visible, and are therefore easier to improve.
 .
 This package contains the worker, which performs the actual builds.
 It is recommended to run the worker on behalf of a non-privileged user.

Package: buildbot-slave
Depends:
 ${misc:Depends},
 buildbot-worker,
Architecture: all
Section: oldlibs
Description: transitional package for buildbot-worker
 This is a transitional package for buildbot-worker. It can safely be
 removed.

Package: python3-buildbot
Depends:
 ${misc:Depends},
 buildbot,
Architecture: all
Section: oldlibs
Description: transitional package for buildbot
 This is a transitional package for buildbot. It can safely be removed.

Package: python3-buildbot-worker
Depends:
 ${misc:Depends},
 buildbot-worker,
Architecture: all
Section: oldlibs
Description: yet another transitional package for buildbot-worker
 This is a yet another transitional package for buildbot-worker. It can
 safely be removed.

Package: python3-buildbot-doc
Depends:
 ${misc:Depends},
 buildbot-doc,
Architecture: all
Multi-Arch: foreign
Section: oldlibs
Description: transitional package for buildbot-doc
 This is a transitional package for buildbot-doc. It can safely be
 removed.

## buildbot 3.4.0

=== Makefile ===
--- 
+++ 
@@ -9,6 +9,7 @@
 PIP ?= $(ROOT_DIR)/$(VENV_NAME)/bin/pip
 PYTHON ?= $(ROOT_DIR)/$(VENV_NAME)/bin/python
 VENV_PY_VERSION ?= python3
+YARN := $(shell which yarnpkg || which yarn)
 
 WWW_PKGS := www/base www/console_view www/grid_view www/waterfall_view www/wsgi_dashboards www/badges
 WWW_EX_PKGS := www/nestedexample www/codeparameter
@@ -60,21 +61,21 @@
 frontend_deps: $(VENV_NAME)
 	$(PIP) install -e pkg
 	$(PIP) install mock wheel buildbot
-	cd www/build_common; yarn install --pure-lockfile
+	cd www/build_common; $(YARN) install --pure-lockfile
 	for i in $(WWW_DEP_PKGS); \
-		do (cd $$i; yarn install --pure-lockfile; yarn run build); done
+		do (cd $$i; $(YARN) install --pure-lockfile; $(YARN) run build); done
 
 frontend_tests: frontend_deps
 	for i in $(WWW_PKGS); \
-		do (cd $$i; yarn install --pure-lockfile); done
+		do (cd $$i; $(YARN) install --pure-lockfile); done
 	for i in $(WWW_PKGS_FOR_UNIT_TESTS); \
-		do (cd $$i; yarn run build-dev || exit 1; yarn run test || exit 1) || exit 1; done
+		do (cd $$i; $(YARN) run build-dev || exit 1; $(YARN) run test || exit 1) || exit 1; done
 
 frontend_tests_headless: frontend_deps
 	for i in $(WWW_PKGS); \
-		do (cd $$i; yarn install --pure-lockfile); done
+		do (cd $$i; $(YARN) install --pure-lockfile); done
 	for i in $(WWW_PKGS_FOR_UNIT_TESTS); \
-		do (cd $$i; yarn run build-dev || exit 1; yarn run test --browsers BBChromeHeadless || exit 1) || exit 1; done
+		do (cd $$i; $(YARN) run build-dev || exit 1; $(YARN) run test --browsers BBChromeHeadless || exit 1) || exit 1; done
 
 # rebuild front-end from source
 frontend: frontend_deps
@@ -92,7 +93,7 @@
 # upgrade FE dependencies
 frontend_yarn_upgrade:
 	for i in $(WWW_PKGS) $(WWW_EX_PKGS) $(WWW_DEP_PKGS); \
-		do (cd $$i; echo $$i; rm -rf yarn.lock; yarn install || echo $$i failed); done
+		do (cd $$i; echo $$i; rm -rf yarn.lock; $(YARN) install || echo $$i failed); done
 
 # install git hooks for validating patches at commit time
 hooks:
@@ -119,10 +120,8 @@
 
 # helper for virtualenv creation
 virtualenv: $(VENV_NAME)   # usage: make virtualenv VENV_PY_VERSION=python3.4
-	$(PIP) install -e pkg \
-		-e 'master[tls,test,docs]' \
-		-e 'worker[test]' \
-		buildbot_www packaging towncrier
+	$(PIP) install -r requirements-minimal.txt \
+		packaging towncrier
 	@echo now you can type following command  to activate your virtualenv
 	@echo . $(VENV_NAME)/bin/activate
 
@@ -158,7 +157,7 @@
 	rm -rf ../bbdocs/docs/$(VERSION)  # in case of re-run
 	cp -r master/docs/_build/html ../bbdocs/docs/$(VERSION)
 	cd ../bbdocs && git pull
-	. .venv/bin/activate && cd ../bbdocs && make && git add . && git commit -m $(VERSION) && git push
+	. .venv/bin/activate && cd ../bbdocs && make && git add docs && git commit -m $(VERSION) && git push
 	@echo When tarballs have been generated by circleci:
 	@echo make finishrelease

=== master/Makefile ===
# developer utilities
pylint:
	pylint -j4 --rcfile=../common/pylintrc buildbot docs/*.py setup.py
	@test ! -f fail

tutorial:
	cd docs/tutorial; $(MAKE) html
flake8:
	flake8 --config=../common/flake8rc buildbot docs/*.py setup.py
rmpyc:
	make -C .. rmpyc

=== master/docs/Makefile ===
all: docs.tgz

dev: clean html

.PHONY: tutorial manual

VERSION := $(shell if [ -n "$$VERSION" ]; then echo $$VERSION; else PYTHONPATH=..:$${PYTHONPATH} python -c 'from buildbot import version; print(version)'; fi)

# sphinx is fastest on Buildbot docs when using around 8 cores. Anything more does not improve the build speed
JOBS := $(shell python -c 'import multiprocessing; print(min(8, multiprocessing.cpu_count()))')

TAR_VERSION := $(shell tar --version)
TAR_TRANSFORM := $(if $(filter bsdtar,$(TAR_VERSION)),-s /^html/$(VERSION)/,--transform s/^html/$(VERSION)/)

docs.tgz: clean html singlehtml
	sed -e 's!href="index.html#!href="#!g' < _build/singlehtml/index.html > _build/html/full.html
	tar -C _build $(TAR_TRANSFORM) -zcf $@ html

# -- Makefile for Sphinx documentation --

# You can set these variables from the command line.
SPHINXOPTS    = -q -W -j $(JOBS)
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html: conf.py
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml: conf.py
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml: conf.py
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle: conf.py
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json: conf.py
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp: conf.py
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp: conf.py
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/BuildbotTutorial.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/BuildbotTutorial.qhc"

devhelp: conf.py
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/BuildbotTutorial"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/BuildbotTutorial"
	@echo "# devhelp"

epub: conf.py
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex: conf.py
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf: conf.py
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	make -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text: conf.py
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man: conf.py
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

changes: conf.py
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck: conf.py
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

spelling: conf.py
	$(SPHINXBUILD) -b spelling $(ALLSPHINXOPTS) $(BUILDDIR)/spelling
	@echo
	@echo "Spelling check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/spelling/output.txt."

doctest: conf.py
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== debian/changelog ===
buildbot (3.4.0-1build1) jammy; urgency=medium

  * No-change rebuild to update maintainer scripts, see LP: 1959054

 -- Dave Jones <dave.jones@canonical.com>  Wed, 16 Feb 2022 16:47:56 +0000

buildbot (3.4.0-1) unstable; urgency=medium

  * Team upload
  * d/copyright: Amend for latest version

  [ Robin Jarry ]
  * New upstream version 3.4.0
  * d/control: update dependencies to alembic

 -- Bastian Germann <bage@debian.org>  Thu, 18 Nov 2021 18:47:52 +0100

buildbot (3.3.0-1) unstable; urgency=medium

  [ Robin Jarry ]
  * New upstream version 3.3.0 (Closes: #984970)
  * Systemd unit files are now in /usr/lib

  [ Camaleón ]
  * Add debconf translations: Spanish (Closes: #987521)

 -- Robin Jarry <robin@jarry.cc>  Fri, 27 Aug 2021 12:21:17 +0200

=== debian/control ===
--- 
+++ 
@@ -12,18 +12,19 @@
  git,
  python3 (>= 3.5),
  python3-setuptools (>= 8.0),
+ python3-alembic (>= 1.6.0),
  python3-autobahn (>= 0.16.0),
  python3-dateutil (>= 1.5),
  python3-future,
  python3-idna,
  python3-jinja2 (>= 2.1),
  python3-jwt,
- python3-migrate (>= 0.9),
  python3-openssl,
  python3-parameterized,
  python3-pkg-resources (>= 8.0),
  python3-service-identity,
- python3-sqlalchemy (>= 1.2.0),
+ python3-sqlalchemy (>= 1.3.0),
+ python3-sqlalchemy (<< 1.5),
  python3-twisted (>= 17.9.0),
  python3-txaio (>= 2.2.2),
  python3-zope.interface (>= 4.1.1),
@@ -46,16 +47,17 @@
 Depends:
  ${misc:Depends},
  ${python3:Depends},
+ python3-alembic (>= 1.6.0),
  python3-autobahn (>= 0.16.0),
  python3-dateutil (>= 1.5),
  python3-idna,
  python3-jinja2 (>= 2.1),
  python3-jwt,
- python3-migrate (>= 0.9),
  python3-openssl,
  python3-pkg-resources (>= 8.0),
  python3-service-identity,
- python3-sqlalchemy (>= 1.2.0),
+ python3-sqlalchemy (>= 1.3.0),
+ python3-sqlalchemy (<< 1.5),
  python3-twisted (>= 17.9.0),
  python3-txaio (>= 2.2.2),
  python3-zope.interface (>= 4.1.1),

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1
export LC_ALL = C.UTF-8
export VERSION = $(shell head -n1 debian/changelog | cut -d' ' -f2 | tr -d '()')
export BUILDBOT_VERSION = $(VERSION)

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
MAKEFLAGS += -j$(NUMJOBS)
else
NUMJOBS = 1
endif

override_dh_auto_clean \
override_dh_auto_configure \
override_dh_auto_build:
	$(@:override_%=%) --buildsystem=pybuild --sourcedirectory=master \
		--package=buildbot
	$(@:override_%=%) --buildsystem=pybuild --sourcedirectory=worker \
		--package=buildbot-worker
	$(@:override_%=%) --sourcedirectory=master/docs \
		--package=buildbot-doc -- JOBS=$(NUMJOBS)

test_env = \
	PYTHONPATH=pkg:{destdir}/{install_dir} \
	PATH=$$PATH:{destdir}/usr/bin
test_command = trial3 --reporter=text buildbot.test buildbot_worker.test

debian/tmp/manpages/%: debian/manpages/%.scdoc
	mkdir -p $(@D)
	scdoc < $< > $@

manpages_src = $(wildcard debian/manpages/*.scdoc)
manpages = $(addprefix debian/tmp/manpages/,$(notdir $(manpages_src:.scdoc=)))

override_dh_auto_install: $(manpages)
	dh_auto_install --buildsystem=pybuild --sourcedirectory=master \
		--package=buildbot
	dh_auto_install --buildsystem=pybuild --sourcedirectory=worker \
		--package=buildbot-worker
	dh_auto_install --sourcedirectory=master/docs \
		--package=buildbot-doc --destdir=debian/buildbot-doc
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test --buildsystem=pybuild -- --system=custom \
		--test-args='$(test_env) $(test_command)'
endif

override_dh_auto_test:
	:

override_dh_installinit:
	dh_installinit --no-scripts

override_dh_installsystemd:
	dh_installsystemd --no-enable --no-start -r --no-restart-after-upgrade
	ln -s /dev/null debian/buildbot/lib/systemd/system/buildbot.service
	ln -s /dev/null debian/buildbot-worker/lib/systemd/system/buildbot-worker.service

%:
	dh $@ --with python3,bash-completion,sphinxdoc

## buildbot 3.5.0

=== debian/changelog ===
buildbot (3.5.0-1) unstable; urgency=medium

  [ Robin Jarry ]
  * New upstream version 3.5.0
  * d/control:
    + update Standards.Version to 4.6.0
    + Add new dependency to python3-txrequests
    + Add B-D on python3-psutil
    + Tighten versioned dep on python3-unidiff

  [ Nilesh Patra ]
  * Add d/salsa-ci.yml

 -- Robin Jarry <robin@jarry.cc>  Tue, 15 Mar 2022 03:43:52 +0530

## buildbot 3.6.1

=== debian/changelog ===
buildbot (3.6.1-1) unstable; urgency=medium

  * New upstream version 3.6.1 (Closes: #1021921)

 -- Robin Jarry <robin@jarry.cc>  Wed, 16 Nov 2022 15:56:47 +0100

## buildbot 3.7.0

=== Makefile ===
--- 
+++ 
@@ -11,7 +11,7 @@
 VENV_PY_VERSION ?= python3
 YARN := $(shell which yarnpkg || which yarn)
 
-WWW_PKGS := www/base www/console_view www/grid_view www/waterfall_view www/wsgi_dashboards www/badges
+WWW_PKGS := www/base www/react-base www/console_view www/grid_view www/waterfall_view www/wsgi_dashboards www/badges
 WWW_EX_PKGS := www/nestedexample www/codeparameter
 WWW_DEP_PKGS := www/guanlecoja-ui www/data_module
 ALL_PKGS := master worker pkg $(WWW_PKGS)
@@ -75,7 +75,7 @@
 	for i in $(WWW_PKGS); \
 		do (cd $$i; $(YARN) install --pure-lockfile); done
 	for i in $(WWW_PKGS_FOR_UNIT_TESTS); \
-		do (cd $$i; $(YARN) run build-dev || exit 1; $(YARN) run test --browsers BBChromeHeadless || exit 1) || exit 1; done
+		do (cd $$i; $(YARN) run build-dev || exit 1; $(YARN) run test $$(if [ $$i != "www/react-base" ]; then echo --browsers BBChromeHeadless; fi) || exit 1) || exit 1; done
 
 # rebuild front-end from source
 frontend: frontend_deps
@@ -133,7 +133,7 @@
 
 release_notes: $(VENV_NAME)
 	test ! -z "$(VERSION)"  #  usage: make release_notes VERSION=0.9.2
-	yes | towncrier --version $(VERSION) --date `date -u  +%F`
+	towncrier build --yes  --version $(VERSION) --date `date -u  +%F`
 	git commit -m "Release notes for $(VERSION)"
 
 $(ALL_PKGS_TARGETS): cleanup_for_tarballs frontend_deps
@@ -169,4 +169,4 @@
 
 pyinstaller: virtualenv
 	$(PIP) install pyinstaller
-	$(VENV_NAME)/bin/pyinstaller -F pyinstaller/buildbot-worker.spec
+	$(VENV_NAME)/bin/pyinstaller pyinstaller/buildbot-worker.spec

=== worker/Makefile ===
# developer utilities
pylint:
	pylint -j4 --rcfile=../common/pylintrc_worker --disable=super-with-arguments,raise-missing-from buildbot_worker setup.py

flake8:
	flake8 --config=../common/flake8rc buildbot_worker setup.py

=== debian/changelog ===
buildbot (3.7.0-2) unstable; urgency=high

  * Team upload
  * Drop d/salsa-ci.yml
  * Patch: avoid deprecation warnings in tests (Closes: #1028779)

 -- Bastian Germann <bage@debian.org>  Sun, 05 Feb 2023 22:57:26 +0100

buildbot (3.7.0-1) unstable; urgency=medium

  * New upstream version 3.7.0 (Closes: #1013381)

 -- Robin Jarry <robin@jarry.cc>  Mon, 19 Dec 2022 17:31:02 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian Python Team <team+python@tracker.debian.org>
 Uploaders: Robin Jarry <robin@jarry.cc>
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Build-Depends:
  debhelper-compat (= 13),
  dh-python (>= 3.20180313~),
@@ -22,6 +22,7 @@
  python3-openssl,
  python3-parameterized,
  python3-pkg-resources (>= 8.0),
+ python3-psutil,
  python3-service-identity,
  python3-sqlalchemy (>= 1.3.0),
  python3-sqlalchemy (<< 1.5),
@@ -30,6 +31,8 @@
  python3-zope.interface (>= 4.1.1),
  python3-mock,
  python3-treq,
+ python3-txrequests,
+ python3-unidiff (>= 0.6.0),
  python3-yaml,
  python3-sphinx,
  python3-sphinx-rtd-theme,
@@ -60,6 +63,8 @@
  python3-sqlalchemy (<< 1.5),
  python3-twisted (>= 17.9.0),
  python3-txaio (>= 2.2.2),
+ python3-txrequests,
+ python3-unidiff (>= 0.6.0),
  python3-zope.interface (>= 4.1.1),
  passwd,
  lsb-base,

## buildbot 3.10.1

=== Makefile ===
--- 
+++ 
@@ -11,12 +11,12 @@
 VENV_PY_VERSION ?= python3
 YARN := $(shell which yarnpkg || which yarn)
 
-WWW_PKGS := www/base www/react-base www/console_view www/grid_view www/waterfall_view www/wsgi_dashboards www/badges
+WWW_PKGS := www/base www/react-base www/console_view www/react-console_view www/grid_view www/react-grid_view www/waterfall_view www/react-waterfall_view www/wsgi_dashboards www/badges
 WWW_EX_PKGS := www/nestedexample www/codeparameter
-WWW_DEP_PKGS := www/guanlecoja-ui www/data_module
+WWW_DEP_PKGS := www/guanlecoja-ui www/data_module www/plugin_support www/react-data-module www/react-ui
 ALL_PKGS := master worker pkg $(WWW_PKGS)
 
-WWW_PKGS_FOR_UNIT_TESTS := $(filter-out www/badges, $(WWW_DEP_PKGS) $(WWW_PKGS))
+WWW_PKGS_FOR_UNIT_TESTS := $(filter-out www/badges www/plugin_support www/react-ui www/react-grid_view, $(WWW_DEP_PKGS) $(WWW_PKGS))
 
 ALL_PKGS_TARGETS := $(addsuffix _pkg,$(ALL_PKGS))
 .PHONY: $(ALL_PKGS_TARGETS)
@@ -60,7 +60,7 @@
 
 frontend_deps: $(VENV_NAME)
 	$(PIP) install -e pkg
-	$(PIP) install mock wheel buildbot
+	$(PIP) install wheel buildbot
 	cd www/build_common; $(YARN) install --pure-lockfile
 	for i in $(WWW_DEP_PKGS); \
 		do (cd $$i; $(YARN) install --pure-lockfile; $(YARN) run build); done
@@ -75,7 +75,7 @@
 	for i in $(WWW_PKGS); \
 		do (cd $$i; $(YARN) install --pure-lockfile); done
 	for i in $(WWW_PKGS_FOR_UNIT_TESTS); \
-		do (cd $$i; $(YARN) run build-dev || exit 1; $(YARN) run test $$(if [ $$i != "www/react-base" ]; then echo --browsers BBChromeHeadless; fi) || exit 1) || exit 1; done
+		do (cd $$i; $(YARN) run build-dev || exit 1; $(YARN) run test $$(if [ $$i != "www/react-base" -a $$i != "www/react-data-module" -a $$i != "www/react-ui" -a $$i != "www/react-grid_view" -a $$i != "www/react-console_view" -a $$i != "www/react-waterfall_view" ]; then echo --browsers BBChromeHeadless; fi) || exit 1) || exit 1; done
 
 # rebuild front-end from source
 frontend: frontend_deps
@@ -116,11 +116,13 @@
 
 $(VENV_NAME):
 	virtualenv -p $(VENV_PY_VERSION) $(VENV_NAME)
-	$(PIP) install -U pip setuptools
+	$(PIP) install -U pip setuptools wheel
 
 # helper for virtualenv creation
 virtualenv: $(VENV_NAME)   # usage: make virtualenv VENV_PY_VERSION=python3.4
-	$(PIP) install -r requirements-minimal.txt \
+	$(PIP) install -r requirements-ci.txt \
+		-r requirements-ciworker.txt \
+		-r requirements-cidocs.txt \
 		packaging towncrier
 	@echo now you can type following command  to activate your virtualenv
 	@echo . $(VENV_NAME)/bin/activate

=== debian/changelog ===
buildbot (3.10.1-2) unstable; urgency=medium

  * Team Upload
  * remove missed dependency on python3-future

 -- Alexandre Detiste <tchet@debian.org>  Mon, 15 Jan 2024 23:31:00 +0100

buildbot (3.10.1-1) unstable; urgency=medium

  * Team Upload
  * remove obsoletes dependencies on python3-mock & python3-future

  [ Robin Jarry ]
  * d/rules: use parsed upstream version
  * New upstream version 3.10.1 (Closes: #1058644)
  * d/patches: rebase on latest version
  * d/patches: force C.UTF-8 locale when building docs (Closes: #1057929)
  * d/control: update dependencies

 -- Alexandre Detiste <tchet@debian.org>  Sat, 06 Jan 2024 00:30:07 +0100

buildbot (3.9.2-2) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTBFS when dh_installsystemd puts units to /usr (Closes: #1052995)

 -- Robin Jarry <robin@jarry.cc>  Fri, 27 Oct 2023 15:09:26 +0200

buildbot (3.9.2-1) unstable; urgency=medium

  * New upstream version 3.9.2

 -- Robin Jarry <robin@jarry.cc>  Tue, 05 Sep 2023 09:20:16 +0200

buildbot (3.9.0-1) unstable; urgency=medium

  * New upstream version 3.9.0
  * d/control: update Standards-Version to 4.6.2
  * d/patches: silence twisted deprecation warning
  * d/rules: silence sqlalchemy uber warning
  * d/control: remove deprecated lsb-base
  * d/rules: fix docs build and clean (Closes: #1043950)

 -- Robin Jarry <robin@jarry.cc>  Tue, 29 Aug 2023 17:03:16 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian Python Team <team+python@tracker.debian.org>
 Uploaders: Robin Jarry <robin@jarry.cc>
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Build-Depends:
  debhelper-compat (= 13),
  dh-python (>= 3.20180313~),
@@ -14,8 +14,8 @@
  python3-setuptools (>= 8.0),
  python3-alembic (>= 1.6.0),
  python3-autobahn (>= 0.16.0),
+ python3-croniter,
  python3-dateutil (>= 1.5),
- python3-future,
  python3-idna,
  python3-jinja2 (>= 2.1),
  python3-jwt,
@@ -29,7 +29,6 @@
  python3-twisted (>= 17.9.0),
  python3-txaio (>= 2.2.2),
  python3-zope.interface (>= 4.1.1),
- python3-mock,
  python3-treq,
  python3-txrequests,
  python3-unidiff (>= 0.6.0),
@@ -67,7 +66,6 @@
  python3-unidiff (>= 0.6.0),
  python3-zope.interface (>= 4.1.1),
  passwd,
- lsb-base,
 Breaks:
  python3-buildbot (<< 1.7.0),
 Replaces:
@@ -132,10 +130,8 @@
 Depends:
  ${misc:Depends},
  ${python3:Depends},
- python3-future,
  python3-twisted (>= 17.9.0),
  passwd,
- lsb-base,
 Breaks:
  buildbot-slave (<< 1.0),
  python3-buildbot-worker (<< 1.7.0),

=== debian/rules ===
--- 
+++ 
@@ -1,9 +1,11 @@
 #!/usr/bin/make -f
+
+include /usr/share/dpkg/pkg-info.mk
 
 export DH_VERBOSE = 1
 export LC_ALL = C.UTF-8
-export VERSION = $(shell head -n1 debian/changelog | cut -d' ' -f2 | tr -d '()')
-export BUILDBOT_VERSION = $(VERSION)
+export BUILDBOT_VERSION = $(DEB_VERSION_UPSTREAM)
+export PYTHONDONTWRITEBYTECODE = 1
 
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
 NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
@@ -19,10 +21,19 @@
 		--package=buildbot
 	$(@:override_%=%) --buildsystem=pybuild --sourcedirectory=worker \
 		--package=buildbot-worker
-	$(@:override_%=%) --sourcedirectory=master/docs \
-		--package=buildbot-doc -- JOBS=$(NUMJOBS)
+	@case $@ in \
+	override_dh_auto_clean) \
+		echo "$(MAKE) -C master/docs clean && $(RM) _trial_temp/"; \
+		$(MAKE) -C master/docs clean && rm -rf _trial_temp/; \
+		;; \
+	override_dh_auto_build) \
+		echo "$(MAKE) -C master/docs html JOBS=$(NUMJOBS)"; \
+		$(MAKE) -C master/docs html JOBS=$(NUMJOBS); \
+		;; \
+	esac
 
 test_env = \
+	SQLALCHEMY_SILENCE_UBER_WARNING=1 \
 	PYTHONPATH=pkg:{destdir}/{install_dir} \
 	PATH=$$PATH:{destdir}/usr/bin
 test_command = trial3 --reporter=text buildbot.test buildbot_worker.test
@@ -54,8 +65,13 @@
 
 override_dh_installsystemd:
 	dh_installsystemd --no-enable --no-start -r --no-restart-after-upgrade
-	ln -s /dev/null debian/buildbot/lib/systemd/system/buildbot.service
-	ln -s /dev/null debian/buildbot-worker/lib/systemd/system/buildbot-worker.service
+	set -e; if test -d debian/buildbot/lib/systemd/system; then \
+		ln -s /dev/null debian/buildbot/lib/systemd/system/buildbot.service; \
+		ln -s /dev/null debian/buildbot-worker/lib/systemd/system/buildbot-worker.service; \
+	else \
+		ln -s /dev/null debian/buildbot/usr/lib/systemd/system/buildbot.service; \
+		ln -s /dev/null debian/buildbot-worker/usr/lib/systemd/system/buildbot-worker.service; \
+	fi
 
 %:
 	dh $@ --with python3,bash-completion,sphinxdoc

=== debian/tests/control ===
Tests: smoke
Restrictions: needs-root, isolation-container, allow-stderr
